#ifndef __ENTITIES
#define __ENTITIES

#include "vectors.h"
#include "fileio.h"

enum{
	kRenderTypeNone=0,
	kRenderTypeModel,
	kRenderTypeCar,
	kRenderTypeGhost
};

enum{
	kPhysicsTypeNone=0,
	kPhysicsTypeCar,
	kPhysicsTypeSolid,
	kPhysicsTypeGhost
};

enum{
	kPhysicsNone=0,
	kPhysicsLocal,
	kPhysicsRemote
};

enum{
	kControlTypeNone=0,
	kControlTypeUserInput,
	kControlTypeAIInput
};

enum{
	kPathTypeCircular=0,
	kPathTypeSin
};

typedef struct{
	tVector3 tfr,tfl,trl,trr,bfr,bfl,brl,brr;
} tCollBox;


enum{
	kLightTypeDot=0,
	kLightTypeSpot,
	kLightTypeDotRefelective,
	kLightTypeDirectionlessDot,
	kLightTypeDirectionlessDotReflective,
	kLightTypeSpecularDot
};

typedef struct{
	tVector3 pos,dir,rgb;		
	float size,radius;	
	int type;
	int onFlags;
	int offFlags;	
} tLightDefinition;

typedef struct{
	int model;
	int shadowModel;
	float maxCollRadius;
	int numCollBoxes;
	int numColors;
	int sparks;
	int randomColor;
	tCollBox *coll;
	tVector3 massCenter;
	int movable,followPath,pathType,liquid,particleStick;
	tFileRef particle;
	float particleAmount,particleSize;
	float pathSize,pathVelo;
	float mass,inertia;
	int numLights;
	tLightDefinition *lights;
} tSolidEntityPhysics;

typedef struct{
	void *next,*prev;
	tVector3 pos,velo,oldPos;
	tMatrix3 dir,rVelo,oldDir;
	int renderType,renderData;
	int physicsType,physicsData,physicsMachine;
	int untouchable;
	int controlType;
	void *soundSource;
	int id;
	int lastFrame;
	int lastRoadIndex;
	int lastActivity;
	int lastPacketSent;
	tVector3 lastVeloSent;
	tMatrix3 lastRVeloSent;
	float zDist;
	void *physics;
	UInt32 regData;
} tGameEntity;

extern tGameEntity *gFirstEntity,*gCameraEntity,*gViewedEntity;

void EntityResetCount();
tGameEntity *EntityNew(tGameEntity *prev);

#endif